--[[##################################################################################

	TriviaMod v 1.02
	     1.6 (by NRJ),        Trivia (by chill). :)
	http://mydc.ru/topic1377.html

--###################################################################################]]--
tCfg = {}
tConf = {mode = "main",showquesmode = 1,start = 0,trivhint = 0,sequentialnum = 0,allowuserstart = 1}
--###################################################################################
path = debug.getinfo(1).source:match("^@(.+[/\\]).-$"):gsub("\\","/")
tCfg.folder = path.."TriviaMod"
tCfg.data = tCfg.folder.."/Data"
tCfg.functions = tCfg.folder.."/Functions"
--###################################################################################
_Profiles = {}
_Scores = {}
_Players = {}
Report = {}

dofile(tCfg.folder.."/settings.lu")

_datamode = ""

_Questions = {n=0}

tTimers = {}
sVersion = 	"1.02"
botmyinfo = "$MyINFO $ALL "..tCfg.bot.." []  (Trivia Mod v"..sVersion..")$ $BOT$$0$"

function OnStartup()
	if loadfile(tCfg.data.."/"..tCfg.TrivConfigFile) then dofile(tCfg.data.."/"..tCfg.TrivConfigFile) end
	if loadfile(tCfg.data.."/"..tCfg.ScoresFile) then dofile(tCfg.data.."/"..tCfg.ScoresFile) end
	if loadfile(tCfg.data.."/"..tCfg.PlayersFile) then dofile(tCfg.data.."/"..tCfg.PlayersFile) end
	if loadfile(tCfg.data.."/"..tCfg.ErrorReportFile) then dofile(tCfg.data.."/"..tCfg.ErrorReportFile) end
	-- 
	dofile(tCfg.functions.."/Commands.lu")
	dofile(tCfg.functions.."/Menu.lu")
	dofile(tCfg.functions.."/Save.lu")
	dofile(tCfg.functions.."/TrivFunc.lu")
	dofile(tCfg.functions.."/DataFunc.lu")
	dofile(tCfg.functions.."/Help.lu")

	if tCfg.regbot == 1 or tConf.mode == "pm" then
		if tCfg.tKey == 1 then Core.RegBot(tCfg.bot,"","",true)
	 	else Core.RegBot(tCfg.bot,"","",false)
		end
		Core.SendToAll(botmyinfo)
	end
	for nick,i in pairs(_Players) do
		if not Core.GetUser(nick,true) and tCfg.delafterexit then
			_Players[nick] = nil
		end
	end
	TrivData.TotalQuestions = GetTotalQues()
	if (tConf.start == 1) then
		TriviaStart()
	end
end

function UserConnected(curUser)
	if tCfg.SendMenu == 1 then SendCommands(curUser) end
	if (tConf.mode == "pm") or (tCfg.regbot == 1) then
		Core.SendToUser(curUser,botmyinfo)
	end
end

RegConnected = UserConnected
OpConnected = UserConnected

function UserDisconnected(curUser)
	if _Players[curUser.sNick] and tCfg.delafterexit then
		_Players[curUser.sNick] = nil
	end
end

RegDisconnected = UserDisconnected
OpDisconnected = UserDisconnected

function OnExit()
	SaveScores()
	SaveConfig()
	SavePlayers()
end

function ChatArrival(curUser,data)
	_datamode = "main"
	if ParseData(curUser,data) then
		return true
	end
end

function ToArrival(curUser,data)
	local _,_,whoTo,mes = string.find(data,"$To:%s+(%S+)%s+From:%s+%S+%s+$(.*)$")
	if (whoTo == tCfg.bot) then
		SendChatToOthers(mes, curUser)
		_datamode = "pm"
		ParseData(curUser,mes)
	end
end

function ParseData(curUser,data)
	data = string.sub(data,1,string.len(data)-1)
	local _,_,sdata = string.find( data, "^%b<>%s(.*)$")
	local _,_,pre,cmd = string.find( data, "^%b<>%s*(%p)(%S+)")
	if (pre and cmd) and pre == CPrefix then
		cmd = string.lower(cmd)
		if tProfiles[curUser.iProfile] == 1 and tFuncCmd[cmd] then
			tFuncCmd[cmd](curUser,data)
			return true
		end
		if tProfilesConfig[curUser.iProfile] == 1 and tFuncConfig[cmd] then
			tFuncConfig[cmd](curUser,data)
			return true
		end
		if tProfilesConfigPlus[curUser.iProfile] == 1 and tFuncConfigPlus[cmd] then
			tFuncConfigPlus[cmd](curUser,data)
			return true
		end
	elseif sdata then
		local corrans = nil
		for _,v in ipairs(TrivData.Answers) do
			if string.lower(sdata) == string.lower(v) then
				corrans = v
			end
		end
		if corrans and (not TrivData.GetQuestion) then
			TrivData.GetQuestion = true
			local ansTime = string.format("%.2f",(os.clock()-TrivData.Start)) -- Get Answering Time in sec.
			local talked = nil
			if string.lower(sdata) == string.lower(corrans) then
				talked = corrans
			end
			if talked then
				if tConf.mode ~= "pm" then
					if tCfg.maintoall then
						Core.SendToAll("<"..curUser.sNick.."> "..corrans)
					else
						SendMsgToPlayers(corrans,curUser)
					end
				end
				local tmpstring = ""
				if (tCfg.showcorrectanswer == 1) then
					tmpstring = " : "..ansTime.." ()."
				end
				SendMsgToPlayers("    : "..curUser.sNick..",  : \""..corrans.."\". : "..TrivData.Points.."."..tmpstring)
				if _Scores[curUser.sNick] then
					_Scores[curUser.sNick].Score = _Scores[curUser.sNick].Score + TrivData.Points
					_Scores[curUser.sNick].AvTime[1] = _Scores[curUser.sNick].AvTime[1] + ansTime
					_Scores[curUser.sNick].AvTime[2] = _Scores[curUser.sNick].AvTime[2] + 1
					_Scores[curUser.sNick].AvTime[3] = tonumber(string.format("%.2f",_Scores[curUser.sNick].AvTime[1]/_Scores[curUser.sNick].AvTime[2]))
				else
					_Scores[curUser.sNick] = {}
					_Scores[curUser.sNick].Score = TrivData.Points
					_Scores[curUser.sNick].Streak = 1
					_Scores[curUser.sNick].AvTime = { tonumber(ansTime),1,tonumber(ansTime) }
				end
				if (tCfg.showcorrectanswer == 1) then
					SendMsgToPlayers(curUser.sNick..":  : ".._Scores[curUser.sNick].Score..",  : ".._Scores[curUser.sNick].AvTime[2]..",    : "..string.format("%.2f",_Scores[curUser.sNick].AvTime[3]).." ().")
				end
				if TrivData.Availans > 1 then
					ShowAnswer()
				end
				UpdateStreak(curUser)
				if not CheckAutostop() then
					ResetMainTimer()
				end
				return true
			end
		end
	end
end

function MainTimer()
	if (table.getn(_Questions) == 0) then
		LoadQuestions()
	end
	if GetQuestion() then
		SendQuestion()
		TrivData.Unanswered = TrivData.Unanswered + 1
	else
		UpdHint()
		if TrivData.GetQuestion then
			ShowAnswer()
			StopStreak()
			CheckAutostop()
		else
			if (tCfg.QuestionMode == 1) then 
				SendHint()
			else
				SendQuestion()
			end
		end
	end
end

function CheckAutostop()
	if (tCfg.autostop and (TrivData.Unanswered == tCfg.autostop)) or (UserAutostop and (TrivData.Unanswered == UserAutostop)) then
		local tmp = UserAutostop or tCfg.autostop
		SendMsgToPlayers("   ,    "..tmp.."         .")
		TriviaStop()
		return true
	elseif TrivData.Pause then
		Pause()
		return true
	end
end

function PauseTimer()
	TrivData.Pause = true
	if tTimers.Pause then TmrMan.RemoveTimer(tTimers.Pause) end
end

function SaveTimer()
	if TrivData.Streak > 0 then
		SaveScores()
	end
end

function TriviaStart()
	TrivData.Unanswered = 0
	TrivData.GetQuestion = true
	tTimers.Main = TmrMan.AddTimer(1000*tCfg.showques,"MainTimer")
	if tCfg.dobreak then
		tTimers.Pause = TmrMan.AddTimer(60000*tCfg.timebreak,"PauseTimer")
	end
	if (tCfg.savestats ~= 0) then
		tTimers.Save = TmrMan.AddTimer(60000*tCfg.savestats,"SaveTimer")
	end
	Started = true
end

function TriviaStop()
	TrivData.GetQuestion = true
	UserAutostop = nil
	SaveScores()
	if tTimers.Main then TmrMan.RemoveTimer(tTimers.Main); tTimers.Main = nil end
	if tTimers.Save then TmrMan.RemoveTimer(tTimers.Save); tTimers.Save = nil end
	if tTimers.Pause then TmrMan.RemoveTimer(tTimers.Pause); tTimers.Pause = nil end
	if tTimers.Continue then TmrMan.RemoveTimer(tTimers.Continue); tTimers.Continue = nil end
	Started = false
	TrivData.Pause = false
end

function ResetMainTimer()
	if tTimers.Main then 
		TmrMan.RemoveTimer(tTimers.Main)
		tTimers.Main = TmrMan.AddTimer(1000*tCfg.showques,"MainTimer")
	end
end

function Pause()
	if tTimers.Main then TmrMan.RemoveTimer(tTimers.Main); tTimers.Main = nil end
	tTimers.Continue = TmrMan.AddTimer(60000*tCfg.breaktime,"Continue")
	SendMsgToPlayers(" !    "..tCfg.breaktime.." ().")
end

function Continue()
	TrivData.Pause = false
	if tTimers.Continue then TmrMan.RemoveTimer(tTimers.Continue); tTimers.Continue = nil end
	tTimers.Main = TmrMan.AddTimer(1000*tCfg.showques,"MainTimer")
	if tCfg.dobreak then
		tTimers.Pause = TmrMan.AddTimer(60000*tCfg.timebreak,"PauseTimer")
	end
	SendMsgToPlayers(" !")
end

function SendMsgToUser(curUser,data)
	if (_datamode == "main") then
		Core.SendToUser(curUser,"<"..tCfg.bot.."> "..data)
	else
		Core.SendPmToUser(curUser,tCfg.bot,data)
	end
end

function SendMsgToPlayers(data,curUser)
	if (tConf.mode == "main") then
		if tCfg.maintoall then
			Core.SendToAll("<"..tCfg.bot.."> "..data)
		else
			local snick = ""
			if curUser then
				snick = curUser.sNick
				data = "<"..curUser.sNick.."> "..data
			else
				data = "<"..tCfg.bot.."> "..data
			end
			for i,_ in pairs(_Players) do
				local user = Core.GetUser(i)
				if user then
					Core.SendToUser(user,data)
				else
					if tCfg.delafterexit then
						_Players[i] = nil
					end
				end
			end
		end
	else
		local snick = ""
		if curUser then
			snick = curUser.sNick
		else
			data = "<"..tCfg.bot.."> "..data
		end
		for i,_ in pairs(_Players) do
			local user = Core.GetUser(i)
			if user then
				if (i ~= snick) then
					Core.SendToUser(user,"$To: "..i.." From: "..tCfg.bot.." $"..data)
				end
			else
				if tCfg.delafterexit then
					_Players[i] = nil
				end
			end
		end
	end
end

function SendChatToOthers(mes, curUser) --         (by NRJ)
    for index, value in pairs(_Players) do
		if (index ~= curUser.sNick) then
			Core.SendToNick(index, "$To: "..index.." From: "..tCfg.bot.." $"..mes)
		end
	end
end

function SetPlayMode(mode)
	if (mode == "main") then 
		if (tCfg.regbot == 0) then
			Core.UnregBot(tCfg.bot)
		end
		tConf.mode = mode
		SaveConfig()
	elseif (mode == "pm") then
		if (tCfg.regbot == 0) then
			Core.RegBot(tCfg.bot,"","",true)
			Core.SendToAll(botmyinfo)
		end
		tConf.mode = mode
		SaveConfig()
	end
end
